{- |
Module      : Model.ServerExceptions
Description : Here are exceptions for debugging.
License     : IPS
Maintainer  : jasonsychau@live.ca
Stability   : provisional
-}
module Model.ServerExceptions where

import Control.Exception


data QueryException = SyntaxException |
                      ParseFragmentException |
                      EmptyQueryException | 
                      InvalidObjectException | 
                      InvalidScalarException |
                      NullArgumentException |
                      CreatingSqlQueryObjectFieldsException |
                      CreatingSqlQueryObjectsException |
                      EOFDataProcessingException1 |
                      EOFDataProcessingException2 |
                      EOFDataProcessingException3 |
                      EOFDataProcessingException4 |
                      EOFDataProcessingException5 |
                      EOFDataProcessingException6 |
                      EOFDataProcessingException7 |
                      EOFDataProcessingException8 |
                      EOFDataProcessingException9 |
                      RelationshipConfigurationException |
                      FailedObjectEqualityException |
                      DuplicateRootObjectsException |
                      ImportSchemaException |
                      ImportSchemaServerNameException |
                      ImportSchemaPseudonymsException |
                      ImportSchemaScalarFieldsException |
                      ImportSchemaObjectFieldsException |
                      ImportSchemaDatabaseTablesException |
                      ImportSchemaDatabaseRelationshipsException |
                      ImportSchemaChildrenException |
                      ImportSchemaDuplicateException |
                      MissingVariableValueException |
                      InvalidVariableNameException |
                      MismatchedVariableTypeException |
                      InvalidVariableTypeException |
                      ReadVariablesException |
                      VariablesSyntaxException |
                      InvalidArgumentException |
                      InvalidObjectSubfieldException
  deriving Show

instance Exception QueryException